#include "../includes/main.h"

// l'initialisation est temporaire, je ne savais pas comment tu voulais la faire

// initialisation des travaux 
Offre **initTabTravaux(void)
{
    trace("initTabTravaux");
    Offre **tabTravaux; 
    
    tabTravaux = (Offre **)malloc(TMAXTRAV* sizeof(Offre *));
    if (!tabTravaux)
    {
        printf("\033[0;31mErreur: \033[0mmalloc tableau tabTravaux\n");
        exit(1);
    }

    // Initialisation de chaque élément du tableau
    tabTravaux[0] = newOffre("Electricite");
    tabTravaux[1] = newOffre("Finitions");
    tabTravaux[2] = newOffre("Fondation");
    tabTravaux[3] = newOffre("Murs");
    tabTravaux[4] = newOffre("Peinture");
    tabTravaux[5] = newOffre("Plomberie");
    tabTravaux[6] = newOffre("Sols");
    tabTravaux[7] = newOffre("Structure");

    return tabTravaux;
} 

/*---------------devis---------------*/

// Chargement d'une chaine de caracteres depuis un fichier
char *readFromFile(FILE *file)
{
    trace("readFromFile");
    char	*str;
    char	*buf;
    int	len = 0;
    int	size = 5;
    int	add = 5;

    str = (char *)malloc(size * sizeof(char));
    if (!str)
        exit(1);

    while (str[len] != '\n')
    {
        len = strlen(str);
        if (len >= size - 1)
        {
            size += add;
            buf = realloc(str, size);
            if (!buf)
            {
                free(str);
                exit(1);
            }
            str = buf;
        }
        fgets(str + len, size - len, file);
        len = strlen(str) - 1;
    }
    str[len] = '\0';
    return (str);
}

// Chargement d'un devis depuis un fichier
void loadDevis(FILE *devisFile, Offre **tabTravaux)
{
    trace("loadDevis");
    int	index;
    char	*travaux;
    Devis	d;

    travaux = readFromFile(devisFile);
    index = rechTravaux(travaux, tabTravaux);
    if (index == -1)
        exit(1);
    d.nomE = readFromFile(devisFile);
    d.adresse = readFromFile(devisFile);
    fscanf(devisFile, "%d\n%d\n%d%*c", &d.capital, &d.duree, &d.prix);
    tabTravaux[index]->ldevis = insert(tabTravaux[index]->ldevis, d);
}

// Chagement des offres depuis le fichier devis.txt
Offre **loadOffre(void)
{
    trace("loadOffre");
    Offre	**tabTravaux = initTabTravaux();

    FILE	*devisFile;

    devisFile = fopen("files/devis.txt", "r");
    if (!devisFile) //ERREUR
        exit(1);

    while (!feof(devisFile))
        loadDevis(devisFile, tabTravaux);

    return (tabTravaux);
}

//---------------------------------------------------------------------------


/*--------------precedences--------------*/

// cas de gros oeuvre avx space, onn a besoin de faire un readfromFile, mais sur \n et \t
// il faut donc rajouter un parametre a RFF qui sera la chaine des char qui pourons definir la fin d'un mot avec le fgets;
// mais dcp, il faut faire des fgets 1 par 1 pour etre sur de ne pas sauter les /t


// NON, on touche plus au RFF, et les fgets 1 par 1 peuvent pas marcher, qui plus est on a pas de gros oeuvre


// Chargement des précédences depuis un fichier
Precedence *loadPrec(int *tmax, int *tlog)
{
    trace("loadPrec");
	FILE *prec;
	Precedence *tabP, *s;
    char *precSuccStr, *precStr;
    int index=0, i;
	prec=fopen("files/precedences.txt", "r");
	if (prec == NULL)
	{
		printf("\033[0;31mErreur: \033[0mouverture de 'precedence.txt'\n");
		exit(1);
	}
	tabP = (Precedence *)malloc((*tmax) * sizeof(Precedence));
    if (tabP == NULL)
    {
        printf("\033[0;31mErreur: \033[0mmalloc loadPrec\n");
        exit(1);
    }
    (*tlog)++;
	while(!feof(prec))
	{
		if(*tlog==*tmax)
		{
			(*tmax)+=5;
			s = (Precedence *)realloc(tabP, (*tmax) * sizeof(Precedence));
			if (s==NULL)
			{
				printf("\033[0;31mErreur: \033[0mreallocation pour fichier précédence\n");
				exit(1);
			}
			tabP = s;
		}
        precSuccStr = readFromFile(prec);
        while (precSuccStr[index] != '\t')
            index++;

        precStr = (char *)malloc((index+1) * sizeof(char));
        for (i=0; i<index; i++)
            precStr[i] = precSuccStr[i];

        strcpy(tabP[*tlog].travauxPrec, precStr);
        strcpy(tabP[*tlog].travauxSucc, precSuccStr+index+1);

        free(precSuccStr);
        free(precStr);

		(*tlog)++;
	}
	fclose(prec);
	return tabP;
}

// Chargement des tâches depuis un fichier pour chaque offre
Tache **loadTaches(Offre *tabTravaux[])
{
    trace("loadTaches");
	Precedence *prec;
	int i, tmaxPrec=5, tlogPrec;
	Tache *t, **tabTache;
	tabTache = (Tache **)malloc(8*sizeof(Tache *));
	if (tabTache == NULL)
	{
		printf("\033[0;31mErreur: \033[0mmalloc tableau tache\n");
		exit(1);
	}
	for (i=0; i<TMAXTRAV; i++)
	{
		t=(Tache *)malloc(sizeof(Tache));
		if (t==NULL)
		{
			printf("\033[0;31mErreur: \033[0mmalloc tache\n");
			exit(1);
		}

		strcpy(t->tache, tabTravaux[i]->travaux);
		t->duree = ((tabTravaux[i]->ldevis)->dev).duree;

		prec = loadPrec(&tmaxPrec, &tlogPrec);

		t->nbPred = nombrePred(tabTravaux[i]->travaux, prec, tlogPrec);
		t->succ = 	lstSucc(tabTravaux[i]->travaux, prec, tlogPrec);

		t->dateDebut=0;
		t->traite=0;

		tabTache[i] = t; 
	}
	return tabTache;
}
